/*
NDS Tactics
Created with devkitpro.org's software
and
LIBNDS from Michael Noland (joat) and Jason Rogers (dovoto)

Copyright (C) 2006 David Galvez Roca AKA: Davgav
Contact me at: davgav@terra.es, Subject: NDSTactics

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/*----------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <nds.h>

#include <nds/arm9/image.h>
#include <nds/arm9/console.h> //basic print funcionality

//incluimos los graficos (se autogeneran a partir de los PCX)
#include "terra_pcx.h"
#include "fondo_pcx.h"
#include "m_negro_pcx.h"
#include "maga_pcx.h"
#include "caballero_pcx.h"
#include "azul_pcx.h"
#include "rojo_pcx.h"
#include "aceptar_pcx.h"
#include "cancelar_pcx.h"
#include "mover_pcx.h"
#include "atacar_pcx.h"
#include "fin_pcx.h"
#include "neosplash_pcx.h"
#include "titulosup_pcx.h"
#include "tituloinf_pcx.h"
#include "winner_pcx.h"
#include "player1_pcx.h"
#include "player2_pcx.h"
#include "gris_pcx.h"
#include "davgav_pcx.h"

#include "cursor_raw.h"
#include "fftabattle_raw.h"
#include "fanfare_raw.h"
#include "hit_raw.h"

#include "text_txt.h"


#define NUM_SPRITES 85
/****defines para facilitar el codigo****************/
#define true 1
#define false 0
#define up 1
#define left 2
#define down 3
#define right 4
#define a 5
#define b 6
#define l 7
#define r 8
#define no 0
#define menu 0
#define mover 1
#define atacar 2
#define fin 3
/****************************************************/

SpriteEntry OAMCopySub[128];
typedef struct{
    u8 sprite;
    int x;
    int y;
	int ant_x;
	int ant_y;
    int dist;
    int vida;
    int fuerza;
    int z;
    int visible;
	int bando;
	int d_atacar;
}datos;

//simple sprite struct
typedef struct {
	int x,y;				//location 
	int dx, dy;			//speed
	SpriteEntry* oam;	
	int gfxID; 				//graphics lovation
}Sprite;

/*******declaracion explicita de funciones***********/
void pintar_fondo_sub(const u8* imagen);
void pintar_fondo_main(const u8* imagen);
void init_text_main(void);
void init(void);
void actualizar_charas(void);
void cargar_sprites(void);
void azules();
int distancia(int x1,int y1,int x2,int y2);
void colocar_menu(void);
void MoveSprite(Sprite* sp);
void initOAM(void);
void updateOAM(void);
void irqVBlank(void);
void definir_charas(void);
int buscarchar(int bc_x,int bc_y);
void muevemalo(void);
void fade_in(void);
void fade_out(void);
void soundoff(void);
void soundon(void);
void playbackmusic(const u8 music[], u32 music_size);
/****************************************************/

Sprite sprites[NUM_SPRITES];

datos chara[8];
datos cuadros[64];
datos flecha;
datos menu_graf[5];
int accion=menu;
int pintar=false;
int pregunta=false;
int numero_char=-1;
int movido=false;
int atacado=false;

int objetivo=rand()%4;
int players=1;

int n_chara=0;
int fondo_array[8][8];
int charas_bando[3]={0,4,4};

char texto[30];

int foto_musica=0;
int long_musica=0;
int musica=false;

//---------------------------------------------------------------------------------
int main(void) {
//---------------------------------------------------------------------------------
	

	int i=0;

	touchPosition touch; //aqui se guardaran los datos de la pantalla tactil
	
	init();	
	cargar_sprites();
	pintar_fondo_main(davgav_pcx);
	pintar_fondo_sub(neosplash_pcx);
	fade_out();
	for (i=0;i<300;i++)
	{
		// read the button states
		scanKeys();
		int pressed = keysDown();	// buttons pressed this loop
		if (pressed)
		break;
		swiWaitForVBlank();
	}
	fade_in();
	pintar_fondo_sub(tituloinf_pcx);
	pintar_fondo_main(titulosup_pcx);
	fade_out();
	players=0;
	while (players==0)
	{
		// read the button states
		scanKeys();
		// read the touchscreen coordinates
		touch=touchReadXY();
		int pressed = keysDown();	// buttons pressed this loop
		if (pressed & KEY_TOUCH)
		{
			if (touch.py<96)
			players=1;
			if (touch.py>96)
			players=2;
		}
		swiWaitForVBlank();
	}
	playGenericSound(cursor_raw, cursor_raw_size);
	fade_in();
	init_text_main();
	pintar_fondo_sub(fondo_pcx);
	fade_out();
	playbackmusic(fftabattle_raw, fftabattle_raw_size);
	while (1) {
		// read the button states
		scanKeys();
		// read the touchscreen coordinates
		touch=touchReadXY();
		int pressed = keysDown();	// buttons pressed this loop
		//int held = keysHeld();		// buttons currently held
		//move the sprites
		while (chara[n_chara].vida<1)
		{
			n_chara++;
		}
		actualizar_charas();
		azules();


		iprintf("\x1b[2;5HHP:%d         ",chara[0].vida);
		iprintf("\x1b[9;5HHP:%d         ",chara[1].vida);
		iprintf("\x1b[15;5HHP:%d         ",chara[2].vida);
		iprintf("\x1b[20;5HHP:%d         ",chara[3].vida);
		iprintf("\x1b[2;22HHP:%d         ",chara[4].vida);
		iprintf("\x1b[9;22HHP:%d         ",chara[5].vida);
		iprintf("\x1b[15;22HHP:%d         ",chara[6].vida);
		iprintf("\x1b[20;22HHP:%d         ",chara[7].vida);

		iprintf("\x1b[3;5H         ");
		iprintf("\x1b[10;5H         ");
		iprintf("\x1b[16;5H         ");
		iprintf("\x1b[21;5H         ");
		iprintf("\x1b[3;24H         ");
		iprintf("\x1b[10;24H         ");
		iprintf("\x1b[16;24H         ");
		iprintf("\x1b[21;24H         ");

			switch (n_chara)
			{
			case (0):
				iprintf("\x1b[3;5H<-         ");
				break;
			case (1):
				iprintf("\x1b[10;5H<-         ");
				break;
			case (2):
				iprintf("\x1b[16;5H<-         ");
				break;
			case (3):
				iprintf("\x1b[21;5H<-         ");
				break;
			case (4):
				iprintf("\x1b[3;24H->         ");
				break;
			case (5):
				iprintf("\x1b[10;24H->         ");
				break;
			case (6):
				iprintf("\x1b[16;24H->         ");
				break;
			case (7):
				iprintf("\x1b[21;24H->         ");
				break;
			}
		iprintf("\x1b[22;9H%s         ",texto);
		if ((chara[n_chara].bando==1 && players==1) || players==2)
		{
			if (accion==menu)
			{
				strcpy(texto,"What to do?");
				if (pressed && KEY_TOUCH)
				{
					if (touch.px>20 && touch.px<52 && touch.py>10 &&touch.py<42 && movido==false)
					{
						accion=mover;
						playGenericSound(cursor_raw, cursor_raw_size);
					}
					if (touch.px>70 && touch.px<102 && touch.py>10 && touch.py<42 && atacado==false)
					{
						accion=atacar;
						playGenericSound(cursor_raw, cursor_raw_size);
					}
					if (touch.px>120 && touch.px<152 && touch.py>10 && touch.py<42)
					{
						playGenericSound(cursor_raw, cursor_raw_size);
						accion=fin;
						movido=false;
						atacado=false;
						n_chara++;
						while (chara[n_chara].vida<1)
						{
							n_chara++;
							if (n_chara>7)
							{
								n_chara=0;
							}
						}
						if (n_chara>7)
						{
							n_chara=0;
						}
						chara[n_chara].ant_x=chara[n_chara].x;
						chara[n_chara].ant_y=chara[n_chara].y;
						accion=menu;
					}
				}
			}
			if (accion==mover)
			{
				if (pregunta==false)
				{
					strcpy(texto,"Where to move?");
					if (pressed & KEY_TOUCH)
					{
						flecha.x=(touch.px-6)/24;
						flecha.y=(touch.py-76)/14;
						if (touch.px>170 && touch.px<202 && touch.py>10 && touch.py<42)
						{
							accion=menu;
						}
						if (flecha.x>-1 && flecha.x<8 && flecha.y>-1 && flecha.y<8)
						{
							if (fondo_array[flecha.x][flecha.y]==1)
							{
								chara[n_chara].ant_x=chara[n_chara].x;
								chara[n_chara].ant_y=chara[n_chara].y;
								chara[n_chara].x=flecha.x;
								chara[n_chara].y=flecha.y;
								strcpy(texto,"Move here?");
								pregunta=true;
								playGenericSound(cursor_raw, cursor_raw_size);
							}
						}
					}
				}
				if (pregunta==true)
				{
					if (touch.px>212 & touch.px<244 & touch.py>77 &touch.py<109)
					{
						playGenericSound(cursor_raw, cursor_raw_size);
						chara[n_chara].ant_x=chara[n_chara].x;
						chara[n_chara].ant_y=chara[n_chara].y;
						pregunta=false;
						accion=menu;
						movido=true;
					}
					if (touch.px>212 & touch.px<244 & touch.py>130 &touch.py<162)
					{
						playGenericSound(cursor_raw, cursor_raw_size);
						chara[n_chara].x=chara[n_chara].ant_x;
						chara[n_chara].y=chara[n_chara].ant_y;
						accion=menu;
						pregunta=false;
					}
				}
			}
			if (accion==atacar)
			{
				if (pregunta==false)
				{
					strcpy(texto,"Who?");
					if (pressed & KEY_TOUCH)
					{
						flecha.x=(touch.px-6)/24;
						flecha.y=(touch.py-76)/14;
						if (touch.px>170 && touch.px<202 && touch.py>10 && touch.py<42)
						{
							playGenericSound(cursor_raw, cursor_raw_size);
							accion=menu;
						}
						if (flecha.x>-1 & flecha.x<8 & flecha.y>-1 & flecha.y<8)
						{
							fondo_array[chara[n_chara].x][chara[n_chara].y]=0;
							if (fondo_array[flecha.x][flecha.y]==1)
							{
								numero_char=buscarchar(flecha.x,flecha.y);
								if (numero_char>-1)
								{
									playGenericSound(cursor_raw, cursor_raw_size);
									strcpy(texto,"Attack this one?");
									pregunta=true;
								}
							}
						}
					}
				}
				if (pregunta==true)
				{
					if (touch.px>212 & touch.px<244 & touch.py>77 &touch.py<109)
					{
						playGenericSound(cursor_raw, cursor_raw_size);
						playGenericSound(hit_raw, hit_raw_size);
						chara[numero_char].vida=chara[numero_char].vida-chara[n_chara].fuerza;
						if (chara[numero_char].vida<1)
						{
							chara[numero_char].y=-7;
							charas_bando[chara[numero_char].bando]--;
							chara[numero_char].vida=0;
						}
						pregunta=false;
						accion=menu;
						atacado=true;
					}
					if (touch.px>212 & touch.px<244 & touch.py>130 &touch.py<162)
					{
						playGenericSound(cursor_raw, cursor_raw_size);
						accion=menu;
						pregunta=false;
					}
				}
			}
		}
		else
		{
			muevemalo();
		}
		if (charas_bando[1]<1)//falta resetear variables
		{
			initOAM();
			soundoff();
			pintar_fondo_main(winner_pcx);
			pintar_fondo_sub(player2_pcx);
			playGenericSound(fanfare_raw, fanfare_raw_size);
			updateOAM();
			while (1)
			{
				scanKeys();
				int pressed = keysDown();	// buttons pressed this loop
				if (pressed)
				break;
				swiWaitForVBlank();
			}
			cargar_sprites();
			definir_charas();
			init_text_main();
			pintar_fondo_sub(fondo_pcx);
			soundon();
		}
		if (charas_bando[2]<1)
		{
			initOAM();
			soundoff();
			pintar_fondo_main(winner_pcx);
			pintar_fondo_sub(player1_pcx);
			playGenericSound(fanfare_raw, fanfare_raw_size);
			updateOAM();
			while (1)
			{
				scanKeys();
				int pressed = keysDown();	// buttons pressed this loop
				if (pressed)
				break;
				swiWaitForVBlank();
			}
			cargar_sprites();
			definir_charas();
			init_text_main();
			pintar_fondo_sub(fondo_pcx);
			soundon();
		}
		swiWaitForVBlank();
		updateOAM();
	}    
	return 0;
}

void muevemalo(void)
{
	int i=1;
	int final=false;
	if (chara[objetivo].vida<1)
	{
		while (chara[objetivo].vida<1)
		{
			objetivo=rand()%4;
		}
	}
	for (int i=0;i<8;i++)
	{
		for (int j=0;j<8;j++)
		{
			fondo_array[j][i]=0;
		}
	}

	for (int j=1;j<8;j++)
	{
		if (j!=n_chara && chara[j].vida>0)
		{
			fondo_array[chara[j].x][chara[j].y]=3;
		}
	}
	i=0;
	while (i<chara[n_chara].dist-1 && final==false)
	{
		if (chara[objetivo].x<chara[n_chara].x)
		{
			chara[n_chara].x--;
			i++;
		}
		else if (chara[objetivo].x>chara[n_chara].x)
		{
			chara[n_chara].x++;
			i++;
		}
		else if (chara[objetivo].y<chara[n_chara].y)
		{
			chara[n_chara].y--;
			i++;
		}
		else if (chara[objetivo].y>chara[n_chara].y)
		{
			chara[n_chara].y++;
			i++;
		}
		else
		{
			i++;
		}
		while (fondo_array[chara[n_chara].x][chara[n_chara].y]==3)
		{
			switch (rand()%4)
			{
				case (0):
					chara[n_chara].x++;
					break;
				case (1):
					chara[n_chara].x--;
					break;
				case (2):
					chara[n_chara].y++;
					break;
				case (3):
					chara[n_chara].y--;
					break;
			}
			if (chara[n_chara].x<0) {chara[n_chara].x=0;}
			if (chara[n_chara].x>7) {chara[n_chara].x=7;}
			if (chara[n_chara].y<0) {chara[n_chara].y=0;}
			if (chara[n_chara].y>7) {chara[n_chara].y=7;}

			final=true;
		}
		if (distancia(chara[objetivo].x,chara[objetivo].y,chara[n_chara].x,chara[n_chara].y)<chara[n_chara].d_atacar-1)
		{
			final=true;
		}
				//reposition the sprites
		azules();
		for (int j=1;j<8;j++)
		{
			if (j!=n_chara && chara[j].vida>0)
			{
				fondo_array[chara[j].x][chara[j].y]=3;
			}
		}
		actualizar_charas();
		updateOAM();
		for (int j=0;j<10;j++)
		{swiWaitForVBlank();}
	}
	if (distancia(chara[objetivo].x,chara[objetivo].y,chara[n_chara].x,chara[n_chara].y)<chara[n_chara].d_atacar-1)
	{
		playGenericSound(hit_raw, hit_raw_size);
		chara[objetivo].vida=chara[objetivo].vida-chara[n_chara].fuerza;
		if (chara[objetivo].vida<1)
		{
			chara[objetivo].vida=0;
			chara[objetivo].y=-7;
			charas_bando[chara[objetivo].bando]--;
		}
	}
	accion=fin;
	movido=false;
	atacado=false;
	n_chara++;
	while (chara[n_chara].vida<1 && charas_bando[1]!=0)
	{
		n_chara++;
		if (n_chara>7)
		{
			n_chara=0;
		}
	}
	if (n_chara>7)
	{
		n_chara=0;
	}
	chara[n_chara].ant_x=chara[n_chara].x;
	chara[n_chara].ant_y=chara[n_chara].y;
	accion=menu;
}

/*******pintar el fondo inferior(en el layer BG3)**************************/		
void pintar_fondo_sub(const u8* imagen)
{
	///////////////set up our bitmap background///////////////////////
	videoSetModeSub(MODE_5_2D | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_SPR_ACTIVE);
	SUB_BG3_CR = BG_BMP8_256x256|BG_MOSAIC_ENABLE;
	//these are rotation backgrounds so you must set the rotation attributes:
    //these are fixed point numbers with the low 8 bits the fractional part
    //this basicaly gives it a 1:1 translation in x and y so you get a nice flat bitmap
		SUB_BG3_XDX = 1 << 8;
		SUB_BG3_XDY = 0;
		SUB_BG3_YDX = 0;
		SUB_BG3_YDY = 1 << 8;
		
	sImage fondo;
	loadPCX((u8*)imagen, &fondo);
	dmaCopy(fondo.data16, BG_GFX_SUB, 256*256);
	dmaCopy(fondo.palette, BG_PALETTE_SUB, 256*2);
	
}
/*********************************************************/		
/*******pintar el fondo superior(en el layer BG3)**************************/		
void pintar_fondo_main(const u8* imagen)
{
	///////////////set up our bitmap background///////////////////////
	videoSetMode(MODE_5_2D | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_SPR_ACTIVE);

	BG3_CR = BG_BMP8_256x256|BG_MOSAIC_ENABLE;
	//these are rotation backgrounds so you must set the rotation attributes:
    //these are fixed point numbers with the low 8 bits the fractional part
    //this basicaly gives it a 1:1 translation in x and y so you get a nice flat bitmap
        BG3_XDX = 1 << 8;
        BG3_XDY = 0;
        BG3_YDX = 0;
        BG3_YDY = 1 << 8;

	sImage fondo;
	loadPCX((u8*)imagen, &fondo);
	dmaCopy(fondo.data16, BG_GFX, 256*256);
//	dmaCopy(fondo.palette, temp_img1.palette, 256*2);
	dmaCopy(fondo.palette, BG_PALETTE, 256*2);
}
/*********************************************************/		
/*******prepara la consola de texto***********************/		
void init_text_main(void)
{
 	////////////////set up text background for text/////////////////////
	videoSetMode(MODE_5_2D | DISPLAY_BG0_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_SPR_ACTIVE);
    BG0_CR = BG_MAP_BASE(31);

	BG_PALETTE[0] = RGB15(0,0,0);
	BG_PALETTE[255] = RGB15(31,31,31);//by default font will be rendered with color 255
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK(31), (u16*)CHAR_BASE_BLOCK(0), 16);
}
/*********************************************************/		
/********inicializa todo el sistema basico****************/		
void init(void)
{
    powerON(POWER_ALL);	//turn everything on
	//irqs are nice
	irqInit();
	irqSet(IRQ_VBLANK, irqVBlank);

    //Elegimos el modo de video para la pantalla superior
	videoSetMode(MODE_5_2D | DISPLAY_BG0_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_SPR_ACTIVE);

    //Elegimos el modo de video para la pantalla inferior
	videoSetModeSub(MODE_5_2D | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_1D_LAYOUT | DISPLAY_SPR_ACTIVE);

    //Asignamos los bancos de memoria
	//pantalla superior->A para el fondo y B para los Sprites
	//pantalla inferior->C para el fondo y D para los Sprites
    vramSetMainBanks(VRAM_A_MAIN_BG, VRAM_B_MAIN_SPRITE,
                     VRAM_C_SUB_BG , VRAM_D_SUB_SPRITE);
}
/*********************************************************/		
void cargar_sprites(void)
{
int i=0;
//////////////////////////// Sprite setup ////////////////////////////////
	sImage chara_img;
	/********terra*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)terra_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
	{
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
		SPRITE_PALETTE[i] = chara_img.palette[i];
	}
	for(i = 0; i< 32*64; i++)
	{	SPRITE_GFX_SUB[i] = chara_img.data16[i];
		SPRITE_GFX[i] = chara_img.data16[i];
	}
	/********mago negro********************/
	//load our ball pcx file into an image
	loadPCX((u8*)m_negro_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
	{
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
		SPRITE_PALETTE[i] = chara_img.palette[i];
	}
	for(i = 0; i< 32*64; i++)
	{
		SPRITE_GFX_SUB[i+32*64] = chara_img.data16[i];
		SPRITE_GFX[i+32*64] = chara_img.data16[i];
	}
	/********maga blanca*******************/
	//load our ball pcx file into an image
	loadPCX((u8*)maga_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
	{	
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
		SPRITE_PALETTE[i] = chara_img.palette[i];
	}
	for(i = 0; i< 32*64; i++)
	{	
		SPRITE_GFX_SUB[i+32*64*2] = chara_img.data16[i];
		SPRITE_GFX[i+32*64*2] = chara_img.data16[i];
	}
	/********caballero*********************/
	//load our ball pcx file into an image
	loadPCX((u8*)caballero_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
	{
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
		SPRITE_PALETTE[i] = chara_img.palette[i];
	}
	for(i = 0; i< 32*64; i++)
	{
		SPRITE_GFX_SUB[i+32*64*3] = chara_img.data16[i];
		SPRITE_GFX[i+32*64*3] = chara_img.data16[i];
	}
	/********azul*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)azul_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4] = chara_img.data16[i];
	/********rojo*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)rojo_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+(32*32/2)] = chara_img.data16[i];
	/********aceptar*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)aceptar_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+32*32] = chara_img.data16[i];
	/********cancelar*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)cancelar_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+32*32*2] = chara_img.data16[i];
	/********mover*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)mover_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+32*32*3] = chara_img.data16[i];
	/********atacar*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)atacar_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+32*32*4] = chara_img.data16[i];
	/********fin*************************/
	//load our ball pcx file into an image
	loadPCX((u8*)fin_pcx, &chara_img);
	//tile it so it is usefull as sprite data
	imageTileData(&chara_img);
	// Sprite initialisation
	for(i = 0; i < 256; i++)
		SPRITE_PALETTE_SUB[i] = chara_img.palette[i];
	for(i = 0; i< 32*32; i++)
		SPRITE_GFX_SUB[i+32*64*4+32*32*5] = chara_img.data16[i];
		
	//turn off sprites
	initOAM();

	for(i = 0; i < NUM_SPRITES; i++) {
		//random place and speed
		sprites[i].x = rand();
		sprites[i].y = rand();
		sprites[i].oam = &OAMCopySub[i];
		sprites[i].gfxID = 0;
	
		//set up our sprites OAM entry attributes
		sprites[i].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_TALL;
		sprites[i].oam->attribute[1] = ATTR1_SIZE_64;
		sprites[i].oam->attribute[2] = sprites[i].gfxID;
		}

	/********definimos los graficos de los charas**/
		sprites[0].oam->attribute[2] = 128*0;
		sprites[1].oam->attribute[2] = 128*1;
		sprites[2].oam->attribute[2] = 128*2;
		sprites[3].oam->attribute[2] = 128*3;
		sprites[4].oam->attribute[2] = 128*0;
		sprites[5].oam->attribute[2] = 128*1;
		sprites[6].oam->attribute[2] = 128*2;
		sprites[7].oam->attribute[2] = 128*3;

	/********giramos los malos*********************/
	for(int i = 4; i < 8; i++)
	{
		sprites[i].oam->attribute[1] = ATTR1_SIZE_64 | ATTR1_FLIP_X;
		sprites[i+77].oam->attribute[1] = ATTR1_SIZE_64 | ATTR1_FLIP_X;
	}

	/********definimos los cuadros*****************/
	for(int i = 8; i < 65+8; i++)
	{
		sprites[i].gfxID = 128*4;
		sprites[i].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
		sprites[i].oam->attribute[1] = ATTR1_SIZE_32;
		sprites[i].oam->attribute[2] = sprites[i].gfxID;
	}

	/********definimos el boton aceptar************/
	sprites[72].gfxID = 128*4+64;
	sprites[72].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
	sprites[72].oam->attribute[1] = ATTR1_SIZE_32;
	sprites[72].oam->attribute[2] = sprites[72].gfxID;
	/********definimos el boton cancelar***********/
	sprites[73].gfxID = 128*5;
	sprites[73].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
	sprites[73].oam->attribute[1] = ATTR1_SIZE_32;
	sprites[73].oam->attribute[2] = sprites[73].gfxID;
	/********definimos el boton mover*************/
	sprites[74].gfxID = 128*5+64;
	sprites[74].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
	sprites[74].oam->attribute[1] = ATTR1_SIZE_32;
	sprites[74].oam->attribute[2] = sprites[74].gfxID;
	/********definimos el boton atacar***********/
	sprites[75].gfxID = 128*6;
	sprites[75].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
	sprites[75].oam->attribute[1] = ATTR1_SIZE_32;
	sprites[75].oam->attribute[2] = sprites[75].gfxID;
	/********definimos el boton atacar***********/
	sprites[76].gfxID = 128*6+64;
	sprites[76].oam->attribute[0] = ATTR0_COLOR_256 | ATTR0_SQUARE;  
	sprites[76].oam->attribute[1] = ATTR1_SIZE_32;
	sprites[76].oam->attribute[2] = sprites[76].gfxID;

	/********definimos los graficos de los charas**/
		sprites[77].oam->attribute[2] = 128*0;
		sprites[78].oam->attribute[2] = 128*1;
		sprites[79].oam->attribute[2] = 128*2;
		sprites[80].oam->attribute[2] = 128*3;
		sprites[81].oam->attribute[2] = 128*0;
		sprites[82].oam->attribute[2] = 128*1;
		sprites[83].oam->attribute[2] = 128*2;
		sprites[84].oam->attribute[2] = 128*3;
	/********coordenadas de los charas*************/
	definir_charas();
}
/*********************************************************/		
void definir_charas(void)
{
	charas_bando[1]=4;
	charas_bando[2]=4;
	n_chara=0;
	movido=false;
	atacado=false;
	objetivo=rand()%4;

    chara[0].x=0;chara[0].y=0;chara[0].dist=6;chara[0].vida=20;chara[0].fuerza=8;chara[0].d_atacar=2;chara[0].bando=1;
    chara[1].x=0;chara[1].y=2;chara[1].dist=3;chara[1].vida=25;chara[1].fuerza=6;chara[1].d_atacar=4;chara[1].bando=1;
    chara[2].x=0;chara[2].y=4;chara[2].dist=3;chara[2].vida=30;chara[2].fuerza=5;chara[2].d_atacar=4;chara[2].bando=1;
    chara[3].x=0;chara[3].y=6;chara[3].dist=5;chara[3].vida=20;chara[3].fuerza=9;chara[3].d_atacar=2;chara[3].bando=1;
    chara[4].x=7;chara[4].y=0;chara[4].dist=6;chara[4].vida=20;chara[4].fuerza=8;chara[4].d_atacar=2;chara[4].bando=2;
    chara[5].x=7;chara[5].y=2;chara[5].dist=3;chara[5].vida=25;chara[5].fuerza=6;chara[5].d_atacar=4;chara[5].bando=2;
    chara[6].x=7;chara[6].y=4;chara[6].dist=3;chara[6].vida=30;chara[6].fuerza=5;chara[6].d_atacar=4;chara[6].bando=2;
    chara[7].x=7;chara[7].y=6;chara[7].dist=5;chara[7].vida=20;chara[7].fuerza=9;chara[7].d_atacar=2;chara[7].bando=2;

	chara[n_chara].ant_x=chara[n_chara].x;
	chara[n_chara].ant_y=chara[n_chara].y;
	accion=menu;
}

void actualizar_charas(void)
{
	colocar_menu();
	int i=0, aux=0, k;
	int chara_y[8];
	int chara_num[8];
	int canvis=false;
/*****************colocamos los charas***************/
//primero ordenamos los charas segun la profundidad
	for(i = 0; i < 8; i++) {
	chara_num[i]=i;
	chara_y[i]=chara[i].y;
	}
	while (1)
	{
		canvis=false;
		for (k=0;k < 7; k++)
		{
			if(chara_y[k]<chara_y[k+1])
			{
 				aux=chara_y[k];
 				chara_y[k]=chara_y[k+1];
 				chara_y[k+1]=aux;
 				aux=chara_num[k];
 				chara_num[k]=chara_num[k+1];
 				chara_num[k+1]=aux;
				canvis=true;
			}
		}
		if (canvis==false)
		{
			break;
		}
	}
//cambiamos los atributos de los sprites de los charas para pintarlos en orden	
	for(i = 0; i < 8; i++) {
		if (chara_num[i]<4)
		{
			sprites[i].oam->attribute[2] = 128*chara_num[i];
			sprites[i].oam->attribute[1] = ATTR1_SIZE_64;
		}
		else
		{
			sprites[i].oam->attribute[2] = 128*(chara_num[i]-4);
			sprites[i].oam->attribute[1] = ATTR1_SIZE_64 | ATTR1_FLIP_X;
		}
		sprites[i].x=((24*chara[chara_num[i]].x)+3) * 0X100;
		sprites[i].y=((14*chara[chara_num[i]].y)+23) * 0X100;
		//reposition the sprites
		MoveSprite(&sprites[i]);
	}
/*****************colocamos los cuadros***************/
	for (int i=0; i<64;i++)
	{
		sprites[i+8].x=((24*cuadros[i].x)+6) * 0x100;
		sprites[i+8].y=((14*cuadros[i].y)+76) * 0x100;
	/*****************cambiamos el color de los cuadros segun la accion***************/

		if (accion==mover)
		{
			sprites[i+8].gfxID = 128*4;
			sprites[i+8].oam->attribute[2] = sprites[i+8].gfxID;
			if (cuadros[i].x==chara[n_chara].x & cuadros[i].y==chara[n_chara].y)
			{
				sprites[i+8].gfxID = 128*4+32;
				sprites[i+8].oam->attribute[2] = sprites[i+8].gfxID;
			}
		}
		if (accion==atacar)
		{
			sprites[i+8].gfxID = 128*4+32;
			sprites[i+8].oam->attribute[2] = sprites[i+8].gfxID;
			if (cuadros[i].x==chara[n_chara].x & cuadros[i].y==chara[n_chara].y)
			{
				sprites[i+8].gfxID = 128*4;
				sprites[i+8].oam->attribute[2] = sprites[i+8].gfxID;
			}
		}
		if (accion==menu)
		{
			sprites[i+8].gfxID = 128*4;
			sprites[i+8].oam->attribute[2] = sprites[i+8].gfxID;
		}
		MoveSprite(&sprites[i+8]);
	}
	/****colocamos boton aceptar***********/
		sprites[72].x=menu_graf[0].x * 0x100;
		sprites[72].y=menu_graf[0].y * 0x100;
	/****colocamos boton cancelar**********/
		sprites[73].x=menu_graf[1].x * 0x100;
		sprites[73].y=menu_graf[1].y * 0x100;
	/****colocamos boton mover**********/
		sprites[74].x=menu_graf[2].x * 0x100;
		sprites[74].y=menu_graf[2].y * 0x100;
	/****colocamos boton atacar**********/
		sprites[75].x=menu_graf[3].x * 0x100;
		sprites[75].y=menu_graf[3].y * 0x100;
	/****colocamos boton fin**********/
		sprites[76].x=menu_graf[4].x * 0x100;
		sprites[76].y=menu_graf[4].y * 0x100;
		for (i=72;i<77;i++)
		{
			MoveSprite(&sprites[i]);
		}
		sprites[77].x=(8) * 0x100;sprites[77].y=(-20) * 0x100;
		sprites[78].x=(8) * 0x100;sprites[78].y=(30) * 0x100;
		sprites[79].x=(8) * 0x100;sprites[79].y=(80) * 0x100;
		sprites[80].x=(8) * 0x100;sprites[80].y=(130) * 0x100;
		sprites[81].x=(215) * 0x100;sprites[81].y=(-20) * 0x100;
		sprites[82].x=(215) * 0x100;sprites[82].y=(30) * 0x100;
		sprites[83].x=(215) * 0x100;sprites[83].y=(80) * 0x100;
		sprites[84].x=(215) * 0x100;sprites[84].y=(130) * 0x100;
		for (i=77;i<85;i++)
		{
			MoveSprite(&sprites[i]);
		}
}
/*************colocar los cuadros azules******************/
void azules()
{
	int i=0;
	int dist=0;
	if (accion==mover)
	{
		dist=chara[n_chara].dist;
	}
	if (accion==atacar)
	{
		dist=chara[n_chara].d_atacar;
	}
	for (int x=0; x<8;x++)
	{
		for (int y=0; y<8;y++)
		{
			if (accion==mover || accion==atacar)
			{
				if (distancia(x,y,chara[n_chara].ant_x,chara[n_chara].ant_y)<dist)
				{
					fondo_array[x][y]=1;
					cuadros[i].x = x;
					cuadros[i].y = y;
					i++;
				}
				else
				{
					fondo_array[x][y]=0;
					cuadros[i].x = -2;
					cuadros[i].y = -2;
					i++;
				}
			}
			else
			{
				if (x==chara[n_chara].x && y==chara[n_chara].y)
				{
					cuadros[i].x = x;
					cuadros[i].y = y;
				}
				else
				{
					cuadros[i].x = -2;
					cuadros[i].y = -2;
				}
				i++;
			}
		}
	}
	for (i=0;i<8;i++)
	{
		if (chara[i].vida>0)
		{
			if (accion==mover)
			{
				fondo_array[chara[i].x][chara[i].y]=0;
			}
		}
	}
}
/*********************************************************/		
/*******calculo de las distancias a ojo*******************/		
int distancia(int x1,int y1,int x2,int y2)
{
	int result=1;
	int x3;
	int y3;
	x3=abs(x1-x2);
	y3=abs(y1-y2);
	result=x3+y3;
	return result;
}
/*********************************************************/
/*******colocamos los elementos que dependen de la accion*/
void colocar_menu(void)
{
/*****************colocamos los menus***************/
	if ((accion==mover || accion==atacar) && pregunta==false)
	{
		menu_graf[1].x=170;menu_graf[1].y=10;
	}
	else if (pregunta)
	{
		menu_graf[0].x=212;menu_graf[0].y=77;
		menu_graf[1].x=212;menu_graf[1].y=130;
	}
	else
	{
		menu_graf[0].x=-100;menu_graf[0].y=-100;
		menu_graf[1].x=-100;menu_graf[1].y=-100;
	}
	/*****************segun si hemos movido o atacado mostramos unos u otros***************/
	if (accion==menu)
	{
		if (movido==false)
		{
			menu_graf[2].x=20;menu_graf[2].y=10;
		}
		else
		{
			menu_graf[2].x=-100;menu_graf[2].y=-100;
		}
		if (atacado==false)
		{
			menu_graf[3].x=70;menu_graf[3].y=10;
		}
		else
		{
			menu_graf[3].x=-100;menu_graf[3].y=-100;
		}
		menu_graf[4].x=120;menu_graf[4].y=10;
	}
	else
	{
		menu_graf[2].x=-100;menu_graf[2].y=-100;
		menu_graf[3].x=-100;menu_graf[3].y=-100;
		menu_graf[4].x=-100;menu_graf[4].y=-100;
	}
}
/*********************************************************/
/**le pasamos una x-y y devuelve el numero del chara que hay ahi**/
int buscarchar(int bc_x,int bc_y)
{
	int i;
	int numero=-1;
	
	for (i=0;i<8;i++)
	{
		if (chara[i].x==bc_x && chara[i].y==bc_y)
		{
			numero=i;
		}
	}
	return numero;
}
/*********************************************************/

//---------------------------------------------------------------------------------
void MoveSprite(Sprite* sp) {
//---------------------------------------------------------------------------------
	int x = sp->x >> 8;
	int y = sp->y >> 8;
	sp->oam->attribute[1] &= 0xFE00;
	sp->oam->attribute[1] |= (x & 0x01FF);
 
	sp->oam->attribute[0] &= 0xFF00;
	sp->oam->attribute[0] |= (y & 0x00FF);
} 
//---------------------------------------------------------------------------------
void initOAM(void) {
//---------------------------------------------------------------------------------
	int i;
	for(i = 0; i < 128; i++)
	{
		OAMCopySub[i].attribute[0] = ATTR0_DISABLED;
	}	
}

//---------------------------------------------------------------------------------
void updateOAM(void) {
//---------------------------------------------------------------------------------
	unsigned int i;
	
	for(i = 0; i < 77 * sizeof(SpriteEntry) / 4 ; i++)
	{
			((uint32*)OAM_SUB)[i] = ((uint32*)OAMCopySub)[i];
	}
	for (i=77;i<85 * sizeof(SpriteEntry) / 4;i++)
	{
			((uint32*)OAM)[i] = ((uint32*)OAMCopySub)[i];
	}
}

void fade_in(void)
{
/*	for (int i=0;i<256;i++)
	{
		SUB_MOSAIC_CR=0x000001*i;
		swiWaitForVBlank();

	}*/
	if (rand()%2==1)
	{
		for (int i=0;i<256;i++)
		{
			BG_PALETTE_SUB[i]=0;
			BG_PALETTE[i]=0;
			swiWaitForVBlank();
		}
	}
	else
	{
		int x=0;
		int y=0;
		int i=0;
		BG_PALETTE_SUB[0]=0;
		BG_PALETTE[0]=0;
		for (x=0;x<256;x++)
		{
			for (y=0;y<192/2;y++)
			{
				BG_GFX[256*192/2-i]=0;
				BG_GFX_SUB[i]=0;
				i++;
			}
			if (x%3==1)
			{
				swiWaitForVBlank();
			}
		}
		for (int i=0;i<256;i++)
		{
			BG_PALETTE_SUB[i]=0;
			BG_PALETTE[i]=0;
		}

	}
//lcdSwap();
}

void fade_out(void)
{
	sImage temp;
	sImage temp2;
	int i=0;
	loadPCX((u8*)gris_pcx, &temp);
	loadPCX((u8*)gris_pcx, &temp2);
	dmaCopy(BG_PALETTE, temp.palette, 256*2);
	dmaCopy(BG_PALETTE_SUB, temp2.palette, 256*2);
	for (i=0;i<256;i++)
	{
		BG_PALETTE[i]=0;
		BG_PALETTE_SUB[i]=0;
	}
	for (i=0;i<256;i++)
	{
		BG_PALETTE[i]=temp.palette[i];
		BG_PALETTE_SUB[i]=temp2.palette[i];
		swiWaitForVBlank();
	}
	dmaCopy(temp.palette, BG_PALETTE, 256*2);
	dmaCopy(temp2.palette, BG_PALETTE_SUB, 256*2);
//lcdSwap();*/
}

void playbackmusic(const u8 music[], u32 music_size)
{
	foto_musica=0;
	long_musica=(music_size*60)/11025;
	musica=true;
	playGenericSound(music, music_size);
}
void irqVBlank(void)
{
	if (musica==true)
	{
		foto_musica++;
	}
	if (musica==true && foto_musica>long_musica)
	{
		playGenericSound(fftabattle_raw, fftabattle_raw_size);
		foto_musica=0;
	}
}
void soundoff(void)
{
	musica=false;
}
void soundon(void)
{
	musica=true;
	foto_musica=long_musica+2;
}
